﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace WinGridRadioButton
{
	public partial class Form1 : Form
	{
		private ControlContainerEditor editor;

		public Form1()
		{
			InitializeComponent();
		}

		private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
		{
			editor = new ControlContainerEditor();
			editor.EditingControl = rbEdit;
			editor.RenderingControlPropertyName = "Checked";
			editor.EditingControlPropertyName = "Checked";
			editor.EnterEditModeMouseBehavior = EnterEditModeMouseBehavior.EnterEditModeAndClick;
			editor.RenderingControl = rbRender;
			e.Layout.Bands[0].Columns[0].Editor = editor;
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			for (int i = 0; i < 20; i++)
			{
				ultraDataSource1.Rows.Add(new object[] { false, "Row " + i.ToString() });
			}
		}

		private void ultraGrid1_CellChange(object sender, CellEventArgs e)
		{
			if (e.Cell.Column.Index == 0)
			{
				var editor = e.Cell.EditorResolved as ControlContainerEditor;
				bool newValue = Boolean.Parse(editor.Value.ToString());
				if (newValue)
				{
					var rows = e.Cell.Row.ParentCollection;
					for (int i = 0; i < rows.Count; i++)
					{
						if (i != e.Cell.Row.Index)
						{
							rows[i].Cells[e.Cell.Column.Index].Value = false;
						}
					}
				}
			}
		}
	}
}
